<template>
  <div class="login">
    <el-form ref="loginForm" :model="loginForm" :rules="loginRules" class="login-form">
      <h3 class="title"> <img src="../assets/images/pic_kqdl_bgs.png" alt="">源潭中学办公管理</h3>
      <el-form-item prop="username" class="nijge">
        <el-input
          v-model="loginForm.username"
          type="text"
          auto-complete="off"
          placeholder="账号"
        >
          <svg-icon slot="prefix" icon-class="user" class="el-input__icon input-icon" />
        </el-input>
      </el-form-item>
      <el-form-item prop="password" v-if='!xgmemberMe' class="nijge">
        <el-input
          v-model="loginForm.password"
          type="password"
          auto-complete="off"
          placeholder="密码"
          @keyup.enter.native="handleLogin"
        >
          <svg-icon slot="prefix" icon-class="password" class="el-input__icon input-icon" />
        </el-input>
      </el-form-item>
      <el-form-item prop="code" v-if="captchaEnabled">
        <el-input
          v-model="loginForm.code"
          auto-complete="off"
          placeholder="验证码"
          style="width: 63%"
          @keyup.enter.native="handleLogin"
        >
          <svg-icon slot="prefix" icon-class="validCode" class="el-input__icon input-icon" />
        </el-input>
        <div class="login-code">
          <img :src="codeUrl" @click="getCode" class="login-code-img"/>
        </div>
      </el-form-item>
      <el-form-item  prop="oldPassword" v-if='xgmemberMe'>
        <el-input v-model="loginForm.oldPassword"  type="password"
          auto-complete="off"
          placeholder="旧密码"
          @keyup.enter.native="handleLogins" >
            <svg-icon slot="prefix" icon-class="password" class="el-input__icon input-icon" />
       </el-input>
      </el-form-item>
      <el-form-item  prop="newPassword" v-if='xgmemberMe'>
        <el-input v-model="loginForm.newPassword"  placeholder="新(数字、大小写字母、特殊符号且大于8位)" type="password" >
          <svg-icon slot="prefix" icon-class="password" class="el-input__icon input-icon" />
        </el-input>
      </el-form-item>
      <el-form-item  prop="confirmPassword" v-if='xgmemberMe'>
        <el-input v-model="loginForm.confirmPassword"  placeholder="确认新密码" type="password" @blur="cpass">
          <svg-icon slot="prefix" icon-class="password" class="el-input__icon input-icon" />
        </el-input>
      </el-form-item>
      <el-checkbox v-model="loginForm.rememberMe" style="margin:0px 0px 25px 0px;">记住密码</el-checkbox>
      <!-- <el-checkbox v-model="xgmemberMe"  @change=" xgmes " style="margin:0px 0px 25px 25px;">修改密码</el-checkbox> -->
      <el-form-item style="width:100%;margin-bottom: 0;" v-if='!xgmemberMe'>
        <el-button
          :loading="loading"
          size="medium"
          type="primary"
          style="width: 100%;background-color: #2865E1;height: 45px;"
          @click.native.prevent="handleLogin"
        >
          <span v-if="!loading">登 录</span>
          <span v-else>登 录 中...</span>
        </el-button>
       <!-- <p class="div_p">
          * 使用快捷登录，请先绑定第三方账号
        </p> -->
      </el-form-item>
      <el-form-item  style="width:100%;margin-bottom: 0;" v-if='xgmemberMe'>
        <el-button
          :loading="loading"
          size="medium"

          type="primary"
          style="width: 100%;background-color: #33a0fe;height: 45px;"
          @click.native.prevent="handleLogins"
        >
          <span v-if="!loading">确认修改</span>
          <span v-else>修 改 中...</span>
        </el-button>
        <p class="div_p">
          * 使用快捷登录，请先绑定第三方账号
        </p>
      </el-form-item>
    </el-form>
    <!--  底部  -->
    <div class="el-login-footer">
      <span></span>
    </div>
  </div>
</template>

<script>
import { getCodeImg } from "@/api/login";
import Cookies from "js-cookie";
import { encrypt, decrypt } from '@/utils/jsencrypt'
 import {setToken} from '@/utils/auth'
  import resetPwd from "./system/user/profile/resetPwd.vue";
  import { updateUserPwds } from "@/api/system/user";

export default {
  name: "Login",
  data() {
    return {
      codeUrl: "",
      loginForm: {
        username: "",
        password: "",
        rememberMe: false,
        code: "",
        uuid: ""
      },
      loginRules: {
        username: [
          { required: true, trigger: "blur", message: "请输入您的账号" }
        ],
        password: [
          { required: true, trigger: "blur", message: "请输入您的密码" }
        ],
        code: [{ required: true, trigger: "change", message: "请输入验证码" }]
      },
      loading: false,
      // 验证码开关
      captchaEnabled: false,
      // 注册开关
      register: false,
      redirect: undefined,
      xgmemberMe:false  //修改密码
    };
  },
  watch: {
    $route: {
      handler: function(route) {
        this.redirect = route.query && route.query.redirect;
      },
      immediate: true
    }
  },
  created() {
    this.getCode();
    this.getCookie();
  },
  methods: {
    getCode() {
      getCodeImg().then(res => {
        this.captchaEnabled = res.captchaEnabled === undefined ? true : res.captchaEnabled;

        if (this.captchaEnabled) {
          this.codeUrl = "data:image/gif;base64," + res.img;
          this.loginForm.uuid = res.uuid;
        }
      });
    },
    getCookie() {
      const username = Cookies.get("username");
      const password = Cookies.get("password");
      const rememberMe = Cookies.get('rememberMe')
      this.loginForm = {
        username: username === undefined ? this.loginForm.username : username,
        password: password === undefined ? this.loginForm.password : decrypt(password),
        rememberMe: rememberMe === undefined ? false : Boolean(rememberMe)
      };
    },
    handleLogin() {
      this.$refs.loginForm.validate(valid => {
        if (valid) {
          this.loading = true;
          if (this.loginForm.rememberMe) {
            Cookies.set("username", this.loginForm.username, { expires: 30 });
            Cookies.set("password", encrypt(this.loginForm.password), { expires: 30 });
            Cookies.set('rememberMe', this.loginForm.rememberMe, { expires: 30 });
          } else {
            Cookies.remove("username");
            Cookies.remove("password");
            Cookies.remove('rememberMe');
          }
          this.$store.dispatch("Login", this.loginForm).then(() => {
            this.$router.push({ path: this.redirect || "/" }).catch(()=>{});
          }).catch(() => {
            this.loading = false;
            if (this.captchaEnabled) {
              this.getCode();
            }
          });
        }
      });
    },
    // 修改密码
    handleLogins(){
     if(this.loginForm.username == ""){
       this.$message.error('请输入账号');
       return
     }
     if(this.loginForm.oldPassword == undefined){
       this.$message.error('请输入旧密码');
       return
     }
     if(this.loginForm.newPassword == undefined){
       this.$message.error('请输入新密码');
       return
     }

     if(this.loginForm.confirmPassword == undefined){
       this.$message.error('请输入确认密码');
       return
     }
     this.loading = true;
     let nhse={
       userName:''
     }
     nhse.userName = this.loginForm.username
     updateUserPwds(this.loginForm.oldPassword, this.loginForm.newPassword,this.loginForm.username).then(
       response => {
         console.log(response.msg,36)
         if(response.msg == '操作成功'){
            this.$modal.msgSuccess(response.msg);
            this.xgmemberMe = false
            this.getCode();
            this.$set(this.loginForm,'password','')
            this.$set(this.loginForm,'uuid','')
            this.$set(this.loginForm,'rememberMe',false)
            this.$set(this.loginForm,'code','')
            this.$set(this.loginForm,'confirmPassword',undefined)
            this.$set(this.loginForm,'oldPassword',undefined)
            this.$set(this.loginForm,'newPassword',undefined)
            // this.$set(this.loginForm,'username','')
         }else{
           this.$message.error(response.msg);
         }

         this.loading = false;

       }
     );
    },
    // 确认密码失去焦点
    cpass(){
     if(this.loginForm.confirmPassword !== this.loginForm.newPassword){
       this.$message.error('两次密码不一致');
     }
    },
    // 复选框选择修改密码
    xgmes(){
      if(this.xgmemberMe == false){
        this.$set(this.loginForm,'confirmPassword',undefined)
        this.$set(this.loginForm,'oldPassword',undefined)
        this.$set(this.loginForm,'newPassword',undefined)
        this.$set(this.loginForm,'username','')
      }else{
        this.$set(this.loginForm,'username','')
        this.$set(this.loginForm,'password','')
        this.$set(this.loginForm,'uuid','')
        this.$set(this.loginForm,'rememberMe',false)
        this.$set(this.loginForm,'code','')
      }
    },
  }
};
</script>

<style rel="stylesheet/scss" lang="scss">
.login {
  display: flex;
  justify-content: center;
  align-items: center;
  height: 100%;
  background-image: url("../assets/images/pic_kqdl_bg.png");
  background-size: cover;
  // margin-left: 300px;
}
.title {
  margin: 0px auto 30px auto;
  text-align: center;
  // color: #06cae1;
  font-weight: bold;
  font-size: 26px;
  color: #343434;
  display: flex;
  align-items: center;
  justify-content: center;
  img{
    margin-right: 10px;
  }
}

.login-form {
  border-radius: 6px;
  background: #000a48;
  background-color:#fff;
  width: 400px;
  margin-right: 40%;
  // margin-left: 10px;
  padding: 25px 25px 5px 25px;
  .nijge{
    .el-form-item__content{
       border-bottom: 1px solid #1678FF;
    }
  }

  .el-input {
    height: 38px;

    input {
      height: 38px;
      border: none;
      border-radius: none;
      background-color: #ffff;

      // border-color: rgba(1, 152, 221,0.2);
      // background-color:rgba(0,0,0,0.3)
    }
  }
  .el-checkbox__inner{
    background-color: #2174f3;
    border-color: rgba(1, 152, 221,0.2);
    background-color:rgba(0,0,0,0.3)
  }
  .input-icon {
    height: 39px;
    width: 14px;
    margin-left: 2px;
  }
  .el-button--primary{
    margin-bottom: 20px;
    background-color: #1e8eee !important;
  }
}
.login-tip {
  font-size: 13px;
  text-align: center;
  color: #bfbfbf;
}
.login-code {
  width: 33%;
  height: 38px;
  float: right;
  img {
    cursor: pointer;
    vertical-align: middle;
  }
}
.el-login-footer {
  height: 40px;
  line-height: 40px;
  position: fixed;
  bottom: 0;
  width: 100%;
  text-align: center;
  color: #fff;
  font-family: Arial;
  font-size: 12px;
  letter-spacing: 1px;
}
.login-code-img {
  height: 38px;
}
.nli{
  .el-button--primary{
    background-color: #33a0fe;
  }
}
</style>
